unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, Sistema,
  ToolWin, RPNCompiler, UDDETopic, UDimensioniS, UDimensioni, ImgList,
  Bifurcation, ActnList;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ImageList1: TImageList;
    Sistema1: TMenuItem;
    Fasi1: TMenuItem;
    Traiettoria1: TMenuItem;
    Nuovo1: TMenuItem;
    N2: TMenuItem;
    Ricalcola1: TMenuItem;
    Eulero051: TMenuItem;
    Opzioni1: TMenuItem;
    Milstein101: TMenuItem;
    Debole1: TMenuItem;
    N101: TMenuItem;
    Deterministico1: TMenuItem;
    RungeKutta401: TMenuItem;
    Speranza1: TMenuItem;
    RicalcolaN1: TMenuItem;
    N4: TMenuItem;
    Interrompi1: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    Uni151: TMenuItem;
    Opzioni2: TMenuItem;
    Separatore1: TMenuItem;
    Italiano1: TMenuItem;
    Inglese1: TMenuItem;
    AvviaDDE1: TMenuItem;
    ProgressBar1: TProgressBar;
    N3: TMenuItem;
    Implicit101: TMenuItem;
    Biforcazione1: TMenuItem;
    N6: TMenuItem;
    N5: TMenuItem;
    PianoCartesiano1: TMenuItem;
    ActionList1: TActionList;
    Ricalcola: TAction;
    Interrompi: TAction;
    Eulero05: TAction;
    Biforcazione2: TMenuItem;
    Iterazioni1: TMenuItem;
    Lyapunov1: TMenuItem;
    Iterata1: TMenuItem;
    Diagramma1: TMenuItem;
    Memoria1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure UpdateMenuItems(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure HelpAboutItemClick(Sender: TObject);
    procedure Nuovo1Click(Sender: TObject);
    procedure Traiettoria1Click(Sender: TObject);
    procedure Ricalcola1Click(Sender: TObject);
    procedure Fasi1Click(Sender: TObject);
    procedure RungeKutta401Click(Sender: TObject);
    procedure Opzioni1Click(Sender: TObject);
    procedure Milstein101Click(Sender: TObject);
    procedure Biforcazione1Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure Speranza1Click(Sender: TObject);
    procedure RicalcolaN1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Interrompi1Click(Sender: TObject);
    procedure Uni151Click(Sender: TObject);
    procedure Italiano1Click(Sender: TObject);
    procedure Inglese1Click(Sender: TObject);
    procedure AvviaDDE1Click(Sender: TObject);
    procedure Implicit101Click(Sender: TObject);
    procedure PianoCartesiano1Click(Sender: TObject);
    procedure Bifdiagram1Click(Sender: TObject);
    procedure Lyapunov1Click(Sender: TObject);
    procedure Iterazioni1Click(Sender: TObject);
    procedure Iterata1Click(Sender: TObject);
    procedure Memoria1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    SEDS: TSistema;
    Bifu: TBifurcation;
    Progress: Integer;
    Startup: Boolean;
    procedure ShowHint(Sender: TObject);
    procedure RemoveNotify(Sender: TObject; var Action: TCloseAction);
    procedure RicalcolaEvent(Sender: TObject);
    procedure FineRicalcolaEvent(Sender: TObject);
    procedure SistemaBar(N: Integer);
    procedure NuovoSistema(S: TSistema);
    procedure NuovaBiforcazione(B: TBifurcation);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses UAboutBox, UCoefficienti, UFasiChild, UComune, UTraiettorieChild,
  UTraiettorie, UFasi, UCoefficientiS, PianoCartesiano, UCoefficientiSD,
  USperanza, USperanzaChild, UParametri, UDistribuzioneChild,
  UIterazioneChild, CustomFunction, UIterataChild, UMemoryStatus, UDiscreto,
  USplashScreen;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  Screen.OnActiveFormChange := UpdateMenuItems;
  TileMode := tbVertical;
  Inglese1Click(nil);
  MemoryStatus := nil;
  Startup := True;
  Randomize;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  StatusBar.SimpleText := Application.Hint;
end;

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

procedure TMainForm.UpdateMenuItems(Sender: TObject);
begin
  WindowCascadeItem.Enabled := MDIChildCount > 0;
  WindowTileItem.Enabled := MDIChildCount > 0;
  WindowArrangeItem.Enabled := MDIChildCount > 0;
  WindowMinimizeItem.Enabled := MDIChildCount > 0;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Screen.OnActiveFormChange := nil;
end;

procedure TMainForm.HelpAboutItemClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.Nuovo1Click(Sender: TObject);
var
  Dim: TDimensioniS;
  Opz: TCoefficientiS;
  DimX, DimB: Integer;
  I, J: Integer;
  S: TSistemaS05;
begin
  Dim := TDimensioniS.Create(Self);
  if Dim.ShowModal = mrOK then begin
    DimX := Dim.SpinEdit1.Value;
    DimB := Dim.SpinEdit2.Value;
    Opz := TCoefficientiS.Create(Self);
    Opz.SetDimension(DimX, DimB);
    if Opz.ShowModal = mrOK then begin
      S := TSistemaS05.Create(Self);
      try
        S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
        S.SetDimension(DimX, DimB);
        for I := 1 to DimX do begin
          S.Origini[I] := StrToFloat(Opz.StringGrid1.Cells[1, I]);
          S.Derive[I].Text := Opz.StringGrid2.Cells[1, I];
          for J := 1 to DimB do begin
            S.Diffusioni[I, J].Text := Opz.StringGrid3.Cells[J, I];
          end;
        end;
        NuovoSistema(S);
      except
        S.Free;
        ShowException(ExceptObject, ExceptAddr);
      end;
    end;
    Opz.Free;
  end;
  Dim.Free;
end;

procedure TMainForm.Traiettoria1Click(Sender: TObject);
var
  Quali: TTraiettorie;
  I: Integer;
  Child: TTraiettorieChild;
begin
  Quali := TTraiettorie.Create(Self);
  Quali.AddComponenti(SEDS.DimX);
  if Quali.ShowModal = mrOK then begin
    Child := TTraiettorieChild.Create(SEDS);
    Child.Caption := 'Piano delle traiettorie';
    for I := 1 to SEDS.DimX do
      if Quali.CheckListBox1.Checked[I - 1] then begin
        Child.PianoTraiettorie1.AddFunzione(SEDS.Componente[I]);
        Child.Caption := Child.Caption + ', ' + Quali.CheckListBox1.Items[I - 1];
      end;
    Child.NE := SEDS.AddOnRecalculate(Child.NotifyEvent);
    Child.OnClose := RemoveNotify;
  end;
  Quali.Free;
end;

procedure TMainForm.RemoveNotify(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
  SEDS.RemoveOnRecalculate((Sender as TComune).NE);
end;

procedure TMainForm.Ricalcola1Click(Sender: TObject);
begin
  SistemaBar(1);
  SEDS.RicalcolaThread(1);
end;

procedure TMainForm.Fasi1Click(Sender: TObject);
var
  Quali: TFasi;
  I, C: Integer;
  Child: TFasiChild;
  XY: array[1..2] of Integer;
  S: string;
begin
  Quali := TFasi.Create(Self);
  Quali.AddComponenti(SEDS.DimX);
  if Quali.ShowModal = mrOK then begin
    C := 0;
    S := '';
    for I := 1 to SEDS.DimX do
      if Quali.CheckListBox1.Checked[I - 1] then begin
        Inc(C);
        if C in [1, 2] then begin
          XY[C] := I;
          S := S + ', ' + Quali.CheckListBox1.Items[I - 1];
        end;
      end;
    if C = 2 then begin
      Child := TFasiChild.Create(SEDS);
      Child.Caption := Child.Caption + S;
      Child.PianoFasi1.X := SEDS.Componente[XY[1]];
      Child.PianoFasi1.Y := SEDS.Componente[XY[2]];
      Child.PianoFasi1.SetParametri(StrToFloat(Quali.Inizio.Text), StrToFloat(Quali.Fine.Text), StrToFloat(Quali.Passo.Text));
      Child.NE := SEDS.AddOnRecalculate(Child.NotifyEvent);
      Child.OnClose := RemoveNotify;
    end else
      MessageDlg('Occorre selezionare 2 componenti!', mtWarning, [mbOK], 0);
  end;
  Quali.Free;
end;

procedure TMainForm.RungeKutta401Click(Sender: TObject);
var
  Dim: TDimensioni;
  Opz: TCoefficienti;
  DimX: Integer;
  I: Integer;
  S: TSistemaDRK;
begin
  Dim := TDimensioni.Create(Self);
  if Dim.ShowModal = mrOK then begin
    DimX := Dim.SpinEdit1.Value;
    Opz := TCoefficienti.Create(Self);
    Opz.SetDimension(DimX);
    if Opz.ShowModal = mrOK then begin
      S := TSistemaDRK.Create(Self);
      try
        S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
        S.SetDimension(DimX);
        for I := 1 to DimX do begin
          S.Origini[I] := StrToFloat(Opz.StringGrid1.Cells[1, I]);
          S.Derive[I].Text := Opz.StringGrid2.Cells[1, I];
        end;
        NuovoSistema(S);
      except
        S.Free;
        ShowException(ExceptObject, ExceptAddr);
      end;
    end;
    Opz.Free;
  end;
  Dim.Free;
end;

procedure TMainForm.Opzioni1Click(Sender: TObject);
begin
  with TParametri.Create(Self) do begin
    Inizio.Text := FloatToStr(SEDS.Inizio);
    Fine.Text := FloatToStr(SEDS.Fine);
    Passo.Text := FloatToStr(SEDS.Passo);
    if ShowModal = mrOK then begin
      SEDS.SetParametri(StrToFloat(Inizio.Text), StrToFloat(Fine.Text), StrToFloat(Passo.Text));
      SistemaBar(1);
      SEDS.RicalcolaThread(1);
    end;
    Free;
  end;
end;

procedure TMainForm.Milstein101Click(Sender: TObject);
var
  Dim: TDimensioni;
  Opz: TCoefficientiSD;
  DimX: Integer;
  I: Integer;
  S: TSistemaS10;
begin
  Dim := TDimensioni.Create(Self);
  if Dim.ShowModal = mrOK then begin
    DimX := Dim.SpinEdit1.Value;
    Opz := TCoefficientiSD.Create(Self);
    Opz.SetDimension(DimX);
    if Opz.ShowModal = mrOK then begin
      S := TSistemaS10.Create(Self);
      try
        S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
        S.SetDimension(DimX);
        for I := 1 to DimX do begin
          S.Origini[I] := StrToFloat(Opz.StringGrid1.Cells[1, I]);
          S.Derive[I].Text := Opz.StringGrid2.Cells[1, I];
          S.Diffusioni[I].Text := Opz.StringGrid3.Cells[1, I];
        end;
        NuovoSistema(S);
      except
        S.Free;
        ShowException(ExceptObject, ExceptAddr);
      end;
    end;
    Opz.Free;
  end;
  Dim.Free;
end;

procedure TMainForm.NuovoSistema(S: TSistema);
begin
  if S <> nil then begin
    if SEDS = nil then begin
      Sistema1.Enabled := True;
      Ricalcola.Enabled := True;
      RicalcolaN1.Enabled := True;
      Speranza1.Enabled := True;
    end else
      SEDS.Free;
    S.AddOnRecalculate(RicalcolaEvent);
    S.OnFineRicalcolo := FineRicalcolaEvent;
    SEDS := S;
    Ricalcola1Click(Self);
  end;
end;

procedure TMainForm.N101Click(Sender: TObject);
var
  Dim: TDimensioniS;
  Opz: TCoefficientiS;
  DimX, DimB: Integer;
  I, J: Integer;
  S: TSistemaW10;
begin
  Dim := TDimensioniS.Create(Self);
  if Dim.ShowModal = mrOK then begin
    DimX := Dim.SpinEdit1.Value;
    DimB := Dim.SpinEdit2.Value;
    Opz := TCoefficientiS.Create(Self);
    Opz.SetDimension(DimX, DimB);
    if Opz.ShowModal = mrOK then begin
      S := TSistemaW10.Create(Self);
      try
        S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
        S.SetDimension(DimX, DimB);
        for I := 1 to DimX do begin
          S.Origini[I] := StrToFloat(Opz.StringGrid1.Cells[1, I]);
          S.Derive[I].Text := Opz.StringGrid2.Cells[1, I];
          for J := 1 to DimB do begin
            S.Diffusioni[I, J].Text := Opz.StringGrid3.Cells[J, I];
          end;
        end;
        NuovoSistema(S);
      except
        S.Free;
        ShowException(ExceptObject, ExceptAddr);
      end;
    end;
    Opz.Free;
  end;
  Dim.Free;
end;

procedure TMainForm.Speranza1Click(Sender: TObject);
var
  Quale: TSperanza;
  Child: TSperanzaChild;
  I: Integer;
begin
  Quale := TSperanza.Create(Self);
  if Quale.ShowModal = mrOK then begin
    Child := TSperanzaChild.Create(SEDS);
    try
      Child.SetParametri(SEDS.DimX, StrToFloat(Quale.Istante.Text));
      for I := 1 to SEDS.DimX do
        Child.Formule[I] := SEDS.Componente[I];
      Child.NE := SEDS.AddOnRecalculate(Child.NotifyEvent);
      Child.OnClose := RemoveNotify;
      Child.RPNCompiler1.Text := Quale.Funzione.Text;
      Child.Funzione.Caption := Quale.Funzione.Text + ' (' + Quale.Istante.Text + ')';
    except
      ShowException(ExceptObject, ExceptAddr);
      Child.Free;
    end;
  end;
  Quale.Free;
end;

procedure TMainForm.RicalcolaN1Click(Sender: TObject);
var
  N: Integer;
begin
  N := StrToInt(InputBox('Opzioni ricalcolo', 'Numero ricalcoli:', '0'));
  SistemaBar(N);
  SEDS.RicalcolaThread(N);
end;

procedure TMainForm.RicalcolaEvent(Sender: TObject);
begin
  Inc(Progress);
  ProgressBar1.Position := Progress;
end;

procedure TMainForm.FineRicalcolaEvent(Sender: TObject);
begin
  Ricalcola.Enabled := True;
  Interrompi.Enabled := False;
  Eulero05.Enabled := True;

  RicalcolaN1.Enabled := True;
  Debole1.Enabled := True;
  Nuovo1.Enabled := True;
  Deterministico1.Enabled := True;
  Opzioni1.Enabled := True;
end;

procedure TMainForm.SistemaBar(N: Integer);
begin
  Ricalcola.Enabled := False;
  Interrompi.Enabled := True;
  Eulero05.Enabled := False;

  RicalcolaN1.Enabled := False;
  Debole1.Enabled := False;
  Nuovo1.Enabled := False;
  Deterministico1.Enabled := False;
  Opzioni1.Enabled := False;
  ProgressBar1.Max := N;
  ProgressBar1.Position := 0;
  Progress := 0;
end;

procedure TMainForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := Eulero05.Enabled = True;
end;

procedure TMainForm.Interrompi1Click(Sender: TObject);
begin
  SEDS.InterrompiRicalcola;
end;

procedure TMainForm.Uni151Click(Sender: TObject);
var
  Opz: TCoefficientiS;
  S: TSistemaS15;
begin
  Opz := TCoefficientiS.Create(Self);
  Opz.SetDimension(1, 1);
  if Opz.ShowModal = mrOK then begin
    S := TSistemaS15.Create(Self);
    try
      S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
      S.Origini[1] := StrToFloat(Opz.StringGrid1.Cells[1, 1]);
      S.Derive[1].Text := Opz.StringGrid2.Cells[1, 1];
      S.Diffusioni[1].Text := Opz.StringGrid3.Cells[1, 1];
      NuovoSistema(S);
    except
      S.Free;
      ShowException(ExceptObject, ExceptAddr);
    end;
  end;
  Opz.Free;
end;

procedure TMainForm.Italiano1Click(Sender: TObject);
begin
  DecimalSeparator := ',';
  Italiano1.Checked := True;
end;

procedure TMainForm.Inglese1Click(Sender: TObject);
begin
  DecimalSeparator := '.';
  Inglese1.Checked := True;
end;

procedure TMainForm.AvviaDDE1Click(Sender: TObject);
begin
  DDETopic := TDDETopic.Create(Self);
  DDETopic.Sistema := @SEDS;
end;

procedure TMainForm.Implicit101Click(Sender: TObject);
var
  Dim: TDimensioni;
  Opz: TCoefficienti;
  DimX: Integer;
  I: Integer;
  S: TSistemaDI1;
begin
  Dim := TDimensioni.Create(Self);
  if Dim.ShowModal = mrOK then begin
    DimX := Dim.SpinEdit1.Value;
    Opz := TCoefficienti.Create(Self);
    Opz.SetDimension(DimX);
    if Opz.ShowModal = mrOK then begin
      S := TSistemaDI1.Create(Self);
      try
        S.SetParametri(StrToFloat(Opz.Inizio.Text), StrToFloat(Opz.Fine.Text), StrToFloat(Opz.Passo.Text));
        S.SetDimension(DimX);
        for I := 1 to DimX do begin
          S.Origini[I] := StrToFloat(Opz.StringGrid1.Cells[1, I]);
          S.Derive[I].Text := Opz.StringGrid2.Cells[1, I];
        end;
        NuovoSistema(S);
      except
        S.Free;
        ShowException(ExceptObject, ExceptAddr);
      end;
    end;
    Opz.Free;
  end;
  Dim.Free;
end;

procedure TMainForm.Biforcazione1Click(Sender: TObject);
var
  B: TBifurcation;
  Coefficienti: TDiscreto;
begin
  Coefficienti := TDiscreto.Create(Self);
  if Coefficienti.ShowModal = mrOk then begin
    B := TBifurcation.Create(Self);
    try
      B.Logistic.Text := Coefficienti.Dinamica.Text;
      B.Derivata.Text := Coefficienti.Derivata.Text;
      B.Seed := StrToFloat(Coefficienti.Seed.Text);
      NuovaBiforcazione(B);
    except
      B.Free;
      ShowException(ExceptObject, ExceptAddr);
    end;
  end;
end;

procedure TMainForm.NuovaBiforcazione(B: TBifurcation);
begin
  if B <> nil then begin
    if Bifu = nil then
      Biforcazione2.Enabled := True
    else
      Bifu.Free;
    Bifu := B;
    Lyapunov1.Enabled := True;
  end;
end;

procedure TMainForm.PianoCartesiano1Click(Sender: TObject);
begin
  with TTraiettorieChild.Create(Self) do
    Caption := 'Piano Cartesiano';
end;

procedure TMainForm.Iterazioni1Click(Sender: TObject);
var
  Child: TIterazioneChild;
begin
  try
    Child := TIterazioneChild.Create(Bifu);
    Child.PianoIterazione1.Funzione := Bifu.Iterazione[0];
  except
    Child.Free;
    ShowException(ExceptObject, ExceptAddr);
  end;
end;

procedure TMainForm.Bifdiagram1Click(Sender: TObject);
var
  Child: TTraiettorieChild;
begin
  Child := TTraiettorieChild.Create(Bifu);
  Child.PianoTraiettorie1.AddMulti(Bifu.Biforcazione);
  Child.Caption := 'Diagramma di biforcazione';
end;

procedure TMainForm.Lyapunov1Click(Sender: TObject);
var
  Child: TTraiettorieChild;
begin
  Child := TTraiettorieChild.Create(Bifu);
  Child.PianoTraiettorie1.AddFunzione(Bifu.Lyapunov);
  Child.Caption := 'Esponente di Lyapunov';
end;

procedure TMainForm.Iterata1Click(Sender: TObject);
var
  Child: TIterataChild;
begin
  Child := TIterataChild.Create(Bifu);
  Child.PianoIterata1.Multi := Bifu.Biforcazione;
  Child.PianoIterata1.Funzione := Bifu.Iterazione[0];
end;

procedure TMainForm.Memoria1Click(Sender: TObject);
begin
  if MemoryStatus = nil then
    MemoryStatus := TMemoryStatus.Create(Self);
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  if Startup then begin
    Startup := False;
    SplashScreen.ShowModal;
  end;
end;

end.
