unit UDDETopic;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Sistema, Buttons, DDEML, ASIConst;

type
  PItemData = ^TItemData;
  TItemData = record
    Item: string;
    hsz1, hsz2: HSz;
    Format: UINT;
    Inizio, Fine, Passo: Extended;
    ComponentiCount: Integer;
    Componenti: PIntegerArray1;
  end;

type
  TDDETopic = class(TForm)
    ListView1: TListView;
    Aggiorna: TSpeedButton;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AggiornaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    hDDE: Longint;
    NS: HSz;
    function SendData(ItemData: PItemData): HDDEDATA;
  public
    { Public declarations }
    Sistema: ^TSistema;
  end;

var
  DDETopic: TDDETopic;

implementation

{$R *.DFM}

const
  XlTable: array[0..7] of Char = 'XlTable'#0;
  NameService: array[0..7] of Char = 'AndSoft'#0;
  Topic: array[0..3] of Char = 'ASI'#0;

procedure AnalizzaItem(ItemData: PItemData);
var
  I: Integer;
  C: string;
begin
  with ItemData^ do
    try
      C := Item;

      I := Pos(';', C);
      Inizio := StrToFloat(Copy(C, 1, I - 1));
      Delete(C, 1, I);
      I := Pos(';', C);
      Fine := StrToFloat(Copy(C, 1, I - 1));
      Delete(C, 1, I);
      I := Pos(';', C);
      Passo := StrToFloat(Copy(C, 1, I - 1));
      Delete(C, 1, I);

      ComponentiCount := 0;
      Componenti := nil;

      while Length(C) <> 0 do begin
        I := Pos(';', C);
        Inc(ComponentiCount, 1);
        ReallocMem(Componenti, ComponentiCount * SizeOf(Integer));
        Componenti[ComponentiCount] := StrToInt(Copy(C, 1, I - 1));
        Delete(C, 1, I);
      end;
    except
      Componenti := nil;
    end;
end;

(* per scontato c' sempre e solo un Topic [ASI] *)
function DDECallBack(CallType, Fmt: UINT; Conv: HConv; hsz1, hsz2: HSZ; Data: HDDEData; Data1, Data2: DWORD): HDDEData stdcall;
var
  ItemBuffer: array[0..255] of Char;
  TopicBuffer: array[0..255] of Char;
  FormatBuffer: array[0..255] of Char;
  ItemData: PItemData;
  ListItem: TListItem;
  I: Integer;
  ConvInfo: TConvInfo;
begin
  Result := 0;
  case CallType of
    XTYP_CONNECT:
      begin
        DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);
      (*  DDEQueryString(DDETopic.hDDE, hsz2, @Service, 255, CP_WINANSI); *)
        if StrComp(TopicBuffer, Topic) = 0 then
          Result := 1
        else
          Result := 0;
      end;
    XTYP_CONNECT_CONFIRM:
      begin
        ConvInfo.cb := SizeOf(TConvInfo);
        DDEQueryConvInfo(Conv, QID_SYNC, @ConvInfo);
      end;
    XTYP_DISCONNECT:
      begin
        DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);
        DDEQueryString(DDETopic.hDDE, hsz2, @ItemBuffer, 255, CP_WINANSI);
      end;
    XTYP_ADVSTART:
      begin
        GetClipboardFormatName(Fmt, @FormatBuffer, 255);
        if StrComp(FormatBuffer, XlTable) = 0 then begin
          DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);
          DDEQueryString(DDETopic.hDDE, hsz2, @ItemBuffer, 255, CP_WINANSI);

          New(ItemData);
          ItemData.Item := ItemBuffer;
          ItemData.hsz1 := hsz1;
          ItemData.hsz2 := hsz2;
          ItemData.Format := Fmt;
          AnalizzaItem(ItemData);

          ListItem := DDETopic.ListView1.Items.Add;
          ListItem.Caption := ItemBuffer;
          ListItem.SubItems.Add(TopicBuffer);
          ListItem.SubItems.Add(FormatBuffer);
          ListItem.Data := ItemData;

          Result := 1;
        end else
          Result := 0;
      end;
    XTYP_ADVREQ:
      begin
      (*  DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);
        DDEQueryString(DDETopic.hDDE, hsz2, @ItemBuffer, 255, CP_WINANSI); *)
        Result := 0;
        for I := 0 to DDETopic.ListView1.Items.Count - 1 do begin
          ListItem := DDETopic.ListView1.Items[I];
          ItemData := PItemData(ListItem.Data);
          if hsz2 = ItemData^.hsz2 then begin
            Result := DDETopic.SendData(ItemData);
            BREAK;
          end;
        end;
      end;
    XTYP_ADVSTOP:
      begin
      (*  DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);  *)
        DDEQueryString(DDETopic.hDDE, hsz2, @ItemBuffer, 255, CP_WINANSI);
        for I := 0 to DDETopic.ListView1.Items.Count - 1 do begin
          ListItem := DDETopic.ListView1.Items[I];
          ItemData := PItemData(ListItem.Data);
          if hsz2 = ItemData^.hsz2 then begin
            Dispose(ItemData);
            ListItem.Delete;
            BREAK;
          end;
        end;
      end;
    XTYP_REQUEST:
      begin
(*        DDEQueryString(DDETopic.hDDE, hsz1, @TopicBuffer, 255, CP_WINANSI);
        DDEQueryString(DDETopic.hDDE, hsz2, @ItemBuffer, 255, CP_WINANSI);
        GetCLipboardFormatName(Fmt, @FormatBuffer, 255);   *)
        Result := 0;
      end;
  else
    Result := 0;
  end;
end;

procedure TDDETopic.FormClose(Sender: TObject; var Action: TCloseAction);
var
  I: Integer;
  ItemData: PItemData;
begin
  inherited;
  Action := caFree;
  for I := 0 to ListView1.Items.Count - 1 do begin
    ItemData := PItemData(ListView1.Items[I].Data);
    if ItemData^.ComponentiCount <> 0 then
      FreeMem(ItemData^.Componenti, ItemData^.ComponentiCount * SizeOf(Integer));
    Dispose(ItemData);
  end;
end;

function TDDETopic.SendData(ItemData: PItemData): HDDEDATA;
var
  DDEPacket: TDDEPacket;
begin
  Result := 0;
  if ItemData^.ComponentiCount = 0 then EXIT;
  DDEPacket := Sistema.FastTableFormat(ItemData^.Inizio, ItemData^.Fine, ItemData^.Passo, ItemData^.ComponentiCount, ItemData^.Componenti);
  Result := DDECreateDataHandle(hDDE, DDEPacket.DDEData, DDEPacket.DDESize, 0, ItemData^.hsz2, ItemData^.Format, 0);
  FreeMem(DDEPacket.DDEData, DDEPacket.DDESize);
end;

procedure TDDETopic.AggiornaClick(Sender: TObject);
begin
  if Sistema^ = nil then Exit;
  DDEPostAdvise(hDDE, 0, 0);
end;

procedure TDDETopic.FormCreate(Sender: TObject);
begin
  hDDE := 0;
  DDEInitialize(hDDE, DDECallBack, CBF_FAIL_REQUESTS or  CBF_FAIL_POKES or
    CBF_FAIL_EXECUTES or CBF_SKIP_REGISTRATIONS or CBF_SKIP_UNREGISTRATIONS, 0);
  NS := DDECreateStringHandle(hDDE, @NameService, CP_WINANSI);
  DDENameService(hDDE, NS, 0, DNS_REGISTER);
end;

procedure TDDETopic.FormDestroy(Sender: TObject);
begin
  DDENameService(hDDE, 0, 0, DNS_UNREGISTER);
  DDEFreeStringHandle(hDDE, NS);
  DDEUninitialize(hDDE);
  DDETopic := nil;
end;

end.
