unit UDistribuzioneChild;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UComunePiano, ImgList, ComCtrls, ToolWin, ExtCtrls,
  RPNCompiler, Distribuzione, ASIConst, PianoCartesiano;

type
  TDistribuzioneChild = class(TComunePiano)
    PianoTraiettorie1: TPianoTraiettorie;
    RPNCompiler1: TRPNCompiler;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    T: Extended;
    D: Integer;
    F: PFunzioneArray;
    Dist: TDistribuzione;
    procedure SetFunzione(Index: Integer; Value: TFunzione);
  public
    { Public declarations }
    property Formule[Index: Integer]: TFunzione write SetFunzione;
    procedure SetParametri(DimX: Integer; AT: Extended);
    procedure NotifyEvent(Sender: TObject); override;
   end;

var
  DistribuzioneChild: TDistribuzioneChild;

implementation

{$R *.dfm}

procedure TDistribuzioneChild.NotifyEvent(Sender: TObject);
var
  I: Integer;
  H: Extended;
  P: PExtendedArray0;
begin
  GetMem(P, SizeOf(Extended) * (D + 1));
  try
    for I := 1 to D do
      P^[I] := F^[I].Valuta(T);
    P^[0] := T;
    H := RPNCompiler1.Eval(P);
    Dist.Valore := H;
  except
  end;
  FreeMem(P, SizeOf(Extended) * (D + 1));
  inherited
end;

procedure TDistribuzioneChild.SetParametri(DimX: Integer; AT: Extended);
begin
  T := AT;
  D := DimX;
  GetMem(F, D * SizeOf(TFunzione));
end;

procedure TDistribuzioneChild.SetFunzione(Index: Integer; Value: TFunzione);
begin
  if Index in [1..D] then
    F^[Index] := Value
  else
    raise Exception.Create('Invalid argument!');
end;

procedure TDistribuzioneChild.FormCreate(Sender: TObject);
begin
  PianoCartesiano := PianoTraiettorie1;
  Dist := TDistribuzione.Create(Self);
  Dist.Min := -3;
  Dist.Max := 3;
  Dist.IntCount := 10;
  PianoTraiettorie1.AddFunzione(Dist.Funzione);
end;

end.
