unit UIterataChild;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UComunePiano, ImgList, ComCtrls, ToolWin, ExtCtrls,
  PianoCartesiano, Menus;

type
  TIterataChild = class(TComunePiano)
    PianoIterata1: TPianoIterata;
    TrackBar1: TTrackBar;
    PopupMenu1: TPopupMenu;
    Minimo1: TMenuItem;
    Massimo1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Minimo1Click(Sender: TObject);
    procedure Massimo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  IterataChild: TIterataChild;

implementation

uses Bifurcation;

{$R *.dfm}

procedure TIterataChild.FormCreate(Sender: TObject);
begin
  PianoCartesiano := PianoIterata1;
end;

procedure TIterataChild.TrackBar1Change(Sender: TObject);
var
  TPI: TPianoIterata;
  B: TBifurcation;
  Value: Extended;
begin
  TPI := PianoIterata1 as TPianoIterata;
  B := (Self.Owner as TBifurcation);
  Value := TrackBar1.Position / 1000.0;
  TrackBar1.Hint := Format('Lambda: %7.3f', [Value]);
  TPI.Funzione := B.Iterazione[Value];
  TPI.Lambda := Value;
end;

procedure TIterataChild.Minimo1Click(Sender: TObject);
var
  S: string;
begin
  with TrackBar1 do begin
    S := FloatToStr(Min / 1000.0);
    if InputQuery('Parametro della biforcazione', 'Valore minimo', S) then
      try
        Min := Round(StrToFloat(S) * 1000);
        Frequency := (Max - Min) div 20;
      except
        ShowException(ExceptObject, ExceptAddr);
      end;
  end;
end;

procedure TIterataChild.Massimo1Click(Sender: TObject);
var
  S: string;
begin
  with TrackBar1 do begin
    S := FloatToStr(Max / 1000.0);
    if InputQuery('Parametro della biforcazione', 'Valore massimo', S) then
      try
        Max := Round(StrToFloat(S) * 1000);
        Frequency := (Max - Min) div 20;
      except
        ShowException(ExceptObject, ExceptAddr);
      end;
  end;
end;

end.
