unit UIterazioneChild;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, UComunePiano, ImgList, ComCtrls, ToolWin, ExtCtrls,
  PianoCartesiano, Menus;

type
  TIterazioneChild = class(TComunePiano)
    PianoIterazione1: TPianoIterazione;
    MainMenu1: TMainMenu;
    Iterazione1: TMenuItem;
    Parametri1: TMenuItem;
    TrackBar1: TTrackBar;
    PopupMenu1: TPopupMenu;
    Minimo1: TMenuItem;
    Massimo1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Parametri1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Minimo1Click(Sender: TObject);
    procedure Massimo1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  IterazioneChild: TIterazioneChild;

implementation

uses UParametriIter, Bifurcation;

{$R *.dfm}

procedure TIterazioneChild.FormCreate(Sender: TObject);
begin
  PianoCartesiano := PianoIterazione1;
end;

procedure TIterazioneChild.Parametri1Click(Sender: TObject);
var
  TPI: TPianoIterazione;
begin
  TPI := PianoIterazione1 as TPianoIterazione;
  with TParametriIter.Create(Self) do begin
    Seed.Text := FloatToStr(TPI.Start);
    Skip.Text := IntToStr(TPI.Skip);
    Iterazioni.Text := IntToStr(TPI.Iter);
    if ShowModal = mrOK then begin
      TPI.Start := StrToFloat(Seed.Text);
      TPI.Skip := StrToInt(Skip.Text);
      TPI.Iter := StrToInt(Iterazioni.Text);
    end;
    Free;
  end;
end;

procedure TIterazioneChild.TrackBar1Change(Sender: TObject);
var
  TPI: TPianoIterazione;
  B: TBifurcation;
  Value: Extended;
begin
  TPI := PianoIterazione1 as TPianoIterazione;
  B := (Self.Owner as TBifurcation);
  Value := TrackBar1.Position / 1000.0;
  TrackBar1.Hint := Format('Lambda: %7.3f', [Value]);
  TPI.Funzione := B.Iterazione[Value];
end;

procedure TIterazioneChild.Minimo1Click(Sender: TObject);
var
  S: string;
begin
  with TrackBar1 do begin
    S := FloatToStr(Min / 1000.0);
    if InputQuery('Parametro della biforcazione', 'Valore minimo', S) then
      try
        Min := Round(StrToFloat(S) * 1000);
        Frequency := (Max - Min) div 20;
      except
        ShowException(ExceptObject, ExceptAddr);
      end;
  end;
end;

procedure TIterazioneChild.Massimo1Click(Sender: TObject);
var
  S: string;
begin
  with TrackBar1 do begin
    S := FloatToStr(Max / 1000.0);
    if InputQuery('Parametro della biforcazione', 'Valore massimo', S) then
      try
        Max := Round(StrToFloat(S) * 1000);
        Frequency := (Max - Min) div 20;
      except
        ShowException(ExceptObject, ExceptAddr);
      end;
  end;
end;

end.
