unit USperanzaChild;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UComune, StdCtrls, PianoCartesiano, RPNCompiler, ASIConst, Distribuzione;

type
  TSperanzaChild = class(TComune)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Media: TLabel;
    Varianza: TLabel;
    Osservazioni: TLabel;
    Button1: TButton;
    RPNCompiler1: TRPNCompiler;
    Label4: TLabel;
    Funzione: TLabel;
    Distribuzione1: TDistribuzione;
    Continuo: TCheckBox;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ContinuoClick(Sender: TObject);
  private
    { Private declarations }
    F: PFunzioneArray;
    D: Integer;
    T: Extended;
    procedure SetFunzione(Index: Integer; Value: TFunzione);
    procedure UpdateLabel;
  public
    { Public declarations }
    property Formule[Index: Integer]: TFunzione write SetFunzione;
    procedure SetParametri(DimX: Integer; AT: Extended);
    procedure NotifyEvent(Sender: TObject); override;
  end;

var
  SperanzaChild: TSperanzaChild;

implementation

{$R *.DFM}

uses Sistema, Main, UTraiettorieChild;

procedure TSperanzaChild.NotifyEvent(Sender: TObject);
var
  I: Integer;
  P: PExtendedArray0;
begin
  GetMem(P, SizeOf(Extended) * (D + 1));
  for I := 1 to D do
    P^[I] := F^[I].Valuta(T);
  P^[0] := T;
  Distribuzione1.Valore := RPNCompiler1.Eval(P);
  UpdateLabel;
  FreeMem(P, SizeOf(Extended) * (D + 1));
end;

procedure TSperanzaChild.FormCreate(Sender: TObject);
begin
  inherited;
  D := 0;
  T := 0;
end;

procedure TSperanzaChild.SetParametri(DimX: Integer; AT: Extended);
begin
  T := AT;
  D := DimX;
  GetMem(F, D * SizeOf(TFunzione));
end;

procedure TSperanzaChild.SetFunzione(Index: Integer; Value: TFunzione);
begin
  if Index in [1..D] then
    F^[Index] := Value
  else
    raise Exception.Create('Invalid argument!');
end;

procedure TSperanzaChild.Button1Click(Sender: TObject);
begin
  Distribuzione1.Clear;
  UpdateLabel;
end;

procedure TSperanzaChild.UpdateLabel;
begin
  Osservazioni.Caption := IntToStr(Distribuzione1.Num);
  if Continuo.Checked then begin
    Media.Caption := FloatToStr(Distribuzione1.Media);
    Varianza.Caption := FloatToStr(Distribuzione1.Varianza);
  end;
end;

procedure TSperanzaChild.FormDestroy(Sender: TObject);
var
  I: Integer;
begin
  inherited;
  for I := 1 to D do F^[I].Free;
  FreeMem(F, D * SizeOf(TFunzione));
end;

procedure TSperanzaChild.ContinuoClick(Sender: TObject);
begin
  UpdateLabel;
end;

end.
